﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;

namespace osm_road
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //We need to set the map unit to meter because we are using Google Map Spherical Mercator projection.
            winformsMap1.MapUnit = GeographyUnit.Meter;

            winformsMap1.BackgroundOverlay.BackgroundBrush = new GeoSolidBrush(GeoColor.FromArgb(255, 198, 255, 255));

            //Sets Google Map as the background map.
            GoogleMapsOverlay googleMapsOverlay = new GoogleMapsOverlay();
            googleMapsOverlay.TileMode = GoogleMapsTileMode.MultiTile;

            winformsMap1.Overlays.Add(googleMapsOverlay);

            ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(@"D:\OpusTrack 9\SHR-roads_01_08_2013\SHR-roads_01_08_2013.shp");
            ShapeFileFeatureLayer.BuildIndexFile(@"D:\OpusTrack 9\SHR-roads_01_08_2013\SHR-roads_01_08_2013.shp", BuildIndexMode.DoNotRebuild);
            worldLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.LocalRoad4;
            worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            Proj4Projection prj4 = new Proj4Projection();
            prj4.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(2957);
            prj4.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
            prj4.Open();

            worldLayer.FeatureSource.Projection = prj4;

            LayerOverlay staticOverlay = new LayerOverlay();
            staticOverlay.Layers.Add("roads", worldLayer);
            winformsMap1.Overlays.Add(staticOverlay);

            //Sets the extent of the map as the bounding box of the shapefile layer as projected (Google Map Spherical Mercator).
            //worldLayer.Open();
            //winformsMap1.CurrentExtent = worldLayer.GetBoundingBox();
            //worldLayer.Close();
            winformsMap1.CurrentExtent = new RectangleShape(-11864853.5418082, 6818455.81236492, -11863969.7408793, 6817825.20845891);
            winformsMap1.Refresh();
        }
     }
}
